unit frmTFnetinfo;
{******************************************************************************
  MUST ALWAYS DISABLE OPTIMIZATION in release, because it causes memory access error
*******************************************************************************}
{$OPTIMIZATION OFF}

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs,
  unTFLite, FMX.Layouts, FMX.Memo, FMX.Edit;

type
  TForm6 = class(TForm)
    txNetfilename: TEdit;
    meNetdata: TMemo;
    Load: TButton;
    lbl1: TLabel;
    procedure LoadClick(Sender: TObject);
  private
    { Private declarations }
    tfnet: TTFLiteInterpreterBase;
  public
    { Public declarations }
  end;

var
  Form6: TForm6;

implementation

{$R *.fmx}

procedure TForm6.LoadClick(Sender: TObject);
var
    i, s: Integer;
    tensinfo: TTensorInfo;
begin
    meNetdata.Lines.BeginUpdate;
    meNetdata.Lines.Clear;
    if txNetfilename.Text='' then
    begin
      meNetdata.Lines.Add('Error:  network file name is empty');
      Exit;
    end;
    tfnet:=TTFLiteInterpreterBase.create(txNetfilename.Text, '');
    meNetdata.Lines.Add('TF Lite library version: '+tfnet.version);
    meNetdata.Lines.Add('');
    meNetdata.Lines.Add('Input tensors count: '+IntToStr(tfnet.inpTensorsCount));
    for i:=0 to tfnet.inpTensorsCount-1 do
    begin
          meNetdata.Lines.Add(Format('Input subtensor %d  ',[i]));
          tensinfo:=tfnet.getInpTensorInfo(i) ;
          meNetdata.Lines.Add('   name: '+tensinfo.name);
          meNetdata.Lines.Add('   dimensions: '+IntToStr(tensinfo.numDims));
          meNetdata.Lines.Add('   data type: '+tensinfo.datatype);
          meNetdata.Lines.Add('   bytes size: '+UIntToStr(tensinfo.byteSize));
          for s in tensinfo.subdims do
              meNetdata.Lines.Add(Format('   subdim %d ',[s]));
    end;
    meNetdata.Lines.Add('');
    meNetdata.Lines.Add('Output tensors count: '+IntToStr(tfnet.outTensorsCount));
    for i:=0 to tfnet.outTensorsCount-1 do
    begin
          meNetdata.Lines.Add(Format('Output subtensor %d  ',[i]));
          tensinfo:=tfnet.getOutTensorInfo(i) ;
          meNetdata.Lines.Add('   name: '+tensinfo.name);
          meNetdata.Lines.Add('   dimensions: '+IntToStr(tensinfo.numDims));
          meNetdata.Lines.Add('   data type: '+tensinfo.datatype);
          meNetdata.Lines.Add('   bytes size: '+UIntToStr(tensinfo.byteSize));
          for s in tensinfo.subdims do
              meNetdata.Lines.Add(Format('   subdim %d ',[s]));
    end;
    meNetdata.Lines.Add('');

    meNetdata.Lines.EndUpdate;
    meNetdata.SelStart:=0;
    meNetdata.SelLength:=0;
    tfnet.Free;
end;

end.
